#include<bits/stdc++.h>
#define fast_io ios_base::Synnc_with_stdio(0); cin.tie(0); cout.tie(0);
#define F first
#define S second
#define pb push_back

typedef long long ll;
using namespace std;
#define int ll

int32_t main()
{
    #ifdef ROADTOBELEGEND
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // ROADTOBELEGEND

    int n,k;
    cin>>n>>k;

    vector< int > a(n);
    for(int i=0;i<n;++i)
        cin>>a[i];

    set< pair< int , int > > st;

    int ans=0, now=0;
    for(int i=0;i<k-1;++i)
        st.insert({a[i],i}), now+=a[i];


    for(int i=k-1;i<n;++i)
    {
        ans=max(ans, i+now+a[i]+1);

        if(!st.empty()){
            pair< int , int > y=*st.begin();
            if(y.F<a[i])
            {
                now+=a[i]; now-=y.F;
                st.erase(y);
                st.insert({a[i],i});
            }
        }
//        if(i==n-1)
//        {
//            for(auto to : st)
//                cout<<to.F<<' '<<to.S<<'\n';
//            return 0;
//        }
//
//        cout<<i<<' '<<ans<<' '<<st.size()<<'\n';

    }
    cout<<ans;

    return 0;
}

